<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Vùng header -->
    <div class="container">
        <div class="text-center">
            <h2>Danh sách người dùng đăng ký</h2>
        </div>
        <div class="form-group">
            <button class="btn btn-success" id="btn-add-user"><i class="fa fa-plus"></i>&nbsp; Thêm user</button>
        </div>
    </div>
    <!-- Vouche Data Table -->
    <div class="container">
        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Firstname</th>
                    <th>lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!-- Vùng Modal -->

    <!-- Create User modal -->
    <div>
        <div id="create-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Create new User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-firstname">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-firstname" name="firstname"
                                        class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-lastname">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-lastname" name="lastname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-subject">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-subject" name="subject" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-country">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-create-country" class="form-control">
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-customerType">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select disabled id="select-create-customerType" class="form-control">
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-registerStatus">Register Status</label>
                                </div>
                                <div class="col-sm-8">
                                    <select disabled id="select-create-registerStatus" class="form-control">
                                        <option value="New">New</option>
                                        <option value="Accepted">Accepted</option>
                                        <option value="Deny">Deny</option>
                                    </select>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-create-user">Insert User</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Update user modal -->
    <div>
        <div id="update-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Chi tiết User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-firstname">Firstname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-firstname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-lastname">Lastname</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-lastname" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-subject">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-subject" name="subject" class="form-control">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-country">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-country" class="form-control">
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-customerType">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-customerType" class="form-control">
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-registerStatus">Register Status</label>
                                </div>
                                <div class="col-sm-8">
                                    <select id="select-update-registerStatus" class="form-control">
                                        <option value="New">New</option>
                                        <option value="Accepted">Accepted</option>
                                        <option value="Denied">Denied</option>
                                    </select>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-update-user">Update User</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete confirm modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Confirm Xóa User</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa user này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-user">Xác nhận</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Hủy bỏ</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
        const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];
        //
        const gUSER_ID_COL = 0
        const gUSER_FIRSTNAME_COL = 1
        const gUSER_LASTNAME_COL = 2
        const gUSER_COUNTRY_COL = 3
        const gUSER_SUBJECT_COL = 4
        const gUSER_CUSTOMER_TYPE_COL = 5
        const gUSER_REGISTER_STATUS_COL = 6
        const gUSER_ACTION_COL = 7
        // Khai báo dataTable
        var gUserTable = $("#user-table").DataTable({
            columns: [
                { data: gUSER_COLS[gUSER_ID_COL] },
                { data: gUSER_COLS[gUSER_FIRSTNAME_COL] },
                { data: gUSER_COLS[gUSER_LASTNAME_COL] },
                { data: gUSER_COLS[gUSER_COUNTRY_COL] },
                { data: gUSER_COLS[gUSER_SUBJECT_COL] },
                { data: gUSER_COLS[gUSER_CUSTOMER_TYPE_COL] },
                { data: gUSER_COLS[gUSER_REGISTER_STATUS_COL] },
                { data: gUSER_COLS[gUSER_ACTION_COL] },
            ],
            columnDefs: [
                { // định nghĩa lại cột action
                    targets: gUSER_ACTION_COL,
                    defaultContent: `<button id="btn-edit" class="btn btn-info">Sửa</button><button id="btn-delete" class ="btn btn-danger">Xóa</button>`
                }
            ]
        });
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading()
        // Gán sự kiện cho nút sửa
        $(document).on("click", "#btn-edit", function () {
            onBtnSuaClick(this)
        })
        // Gán sự kiện cho nút xóa
        $(document).on("click", "#btn-delete", function () {
            onBtnXoaClick(this)

        })
        // Gán sự kiện cho nút thêm user
        $(document).on("click", "#btn-add-user", function () {
            $("#create-user-modal").modal("show")
        })
        // Gán sự kiện cho nút insert user trong modal thêm user
        $(document).on("click", "#btn-create-user", function () {
            var vUserObject = {
                firstname: "",
                lastname: "",
                subject: "",
                country: "",
                customerType: "",
                registerStatus: ""
            }
            // B1 thu thập dữ liệu
            getDataToAddUser(vUserObject);
            // B2 Kiểm tra dữ liệu
            var vValidate = isDataValidate(vUserObject)
            if (vValidate == true) {
                // B3 Gọi Api 
                processingApiToAddUser(vUserObject)
                // B4 Xử lý hiển thị

            }
        })
        // Gán sự kiện cho nút cập nhật user trong modal sửa
        $(document).on("click", "#btn-update-user", function () {
            var vUserObject = {
                firstname: "",
                lastname: "",
                subject: "",
                country: "",
                customerType: "",
                registerStatus: ""
            }
            // B1 Thu thập dữ liệu 
            getDataToUpdateUser(vUserObject)
            // B2 Kiểm tra dữ liệu
            var vValidate = isDataValidate(vUserObject)
            if (vValidate == true) {
                //B3 Gọi Api
                processingApiToUpdateUser(vUserObject)
            }
        })
        // Gán sự kiện cho nút confirm xóa User
        $(document).on("click", "#btn-confirm-delete-user", function () {
            // B1 thu thập dữ liệu [ Không có]
            // B2 Kiểm tra dữ liệu [ Không có]
            // B3 Gọi Api
            processingApiToDeleteUser()
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm thực thi khi trang được load
        function onPageLoading() {
            getAllUser();
        }
        // Hàm xử lý sự kiện nút sửa
        function onBtnSuaClick(paramBtnSua) {
            var vRowSelected = $(paramBtnSua).parents("tr")
            var vDataRow = gUserTable.row(vRowSelected).data()
            var vId = vDataRow.id
            $("#btn-update-user").attr("id-object", `${vId}`)
            $("#input-update-firstname").val(vDataRow.firstname)
            $("#input-update-lastname").val(vDataRow.lastname)
            $("#input-update-subject").val(vDataRow.subject)
            $("#select-update-country").val(vDataRow.country)
            $("#select-update-customerType").val(vDataRow.customerType)
            $("#select-update-registerStatus").val(vDataRow.registerStatus)
            $("#update-user-modal").modal("show")

        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm get dữ liệu để điền vào table
        function getAllUser() {
            $.ajax({
                url: gBASE_URL,
                type: "GET",
                success: function (paramResponseObject) {
                    //Điền dữ liệu vào table
                    loadDataToUserTable(paramResponseObject);
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            })
        }
        // Hàm điền dữ liệu vào table
        function loadDataToUserTable(paramObject) {
            gUserTable.clear();
            gUserTable.rows.add(paramObject);
            gUserTable.draw();
        }
        // Hàm thu thập dữ liệu cho việc thêm user
        function getDataToAddUser(paramObject) {
            paramObject.firstname = $.trim($("#input-create-firstname").val())
            paramObject.lastname = $.trim($("#input-create-lastname").val())
            paramObject.subject = $.trim($("#input-create-subject").val())
            paramObject.country = $.trim($("#select-create-country").val())
            paramObject.customerType = $.trim($("#select-create-customerType").val())
            paramObject.registerStatus = $.trim($("#select-create-registerStatus").val())
        }
        // Hàm kiểm tra dữ liệu cho việc thêm user
        function isDataValidate(paramObject) {
            if (paramObject.firstname == "") {
                alert("hãy nhập firstname")
                return false
            }
            if (paramObject.lastname == "") {
                alert("hãy nhập lastname")
                return false
            }
            if (paramObject.subject == "") {
                alert("hãy nhập subject")
                return false
            }
            if (paramObject.country == "") {
                alert("hãy chọn country")
                return false
            }
            if (paramObject.customerType == "") {
                alert("hãy chọn customerType")
                return false
            }
            if (paramObject.registerStatus == "") {
                alert("hãy chọn registerStatus")
                return false
            }
            return true
        }
        //hàm gọi Api xử lý thêm user lên server
        function processingApiToAddUser(paramObject) {
            $.ajax({
                url: gBASE_URL,
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(paramObject),
                type: "POST",
                success: function (ResponseObject) {
                    displayAddSuccess(ResponseObject)

                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            })
        }
        //Hàm hiển thị khi thêm user thành công
        function displayAddSuccess(ResponseObject) {
            // Xóa trăng các Input và đặt select về giá trị ban đầu
            $("#input-create-firstname").val("")
            $("#input-create-lastname").val("")
            $("#input-create-subject").val("")
            $("#select-create-country").val("VN")
            $("#select-create-customerType").val("Standard")
            $("#select-create-registerStatus").val("New")
            $("#create-user-modal").modal("hide")
            // Hiện thông báo thêm user thành công
            alert(`
        Đã thêm user thành công 
        Id của bạn là: ${ResponseObject.id}`)
            // Load lại bảng
            getAllUser()
        }
        // Hàm thu thập dữ liệu cho việc cập nhật user
        function getDataToUpdateUser(paramObject) {
            paramObject.firstname = $.trim($("#input-update-firstname").val())
            paramObject.lastname = $.trim($("#input-update-lastname").val())
            paramObject.subject = $.trim($("#input-update-subject").val())
            paramObject.country = $.trim($("#select-update-country").val())
            paramObject.customerType = $.trim($("#select-update-customerType").val())
            paramObject.registerStatus = $.trim($("#select-update-registerStatus").val())
        }
        //hàm gọi Api xử lý thêm update lên server
        function processingApiToUpdateUser(paramObject) {
            $.ajax({
                url: gBASE_URL + $("#btn-update-user").attr("id-object"),
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(paramObject),
                type: "PUT",
                success: function (ResponseObject) {
                    displayUpdateSuccess(ResponseObject)

                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            })
        }
        //Hàm hiển thị khi update user thành công
        function displayUpdateSuccess(ResponseObject) {
            // Xóa trăng các Input và đặt select về giá trị ban đầu
            $("#input-update-firstname").val("")
            $("#input-update-lastname").val("")
            $("#input-update-subject").val("")
            $("#select-update-country").val("VN")
            $("#select-update-customerType").val("Standard")
            $("#select-update-registerStatus").val("New")
            $("#update-user-modal").modal("hide")
            // Hiện thông báo update user thành công
            alert(`
        Đã cập nhật thành công user: ${ResponseObject.firstname} ${ResponseObject.lastname}
        `)
            // Load lại bảng
            getAllUser()
        }
        // Hàm xử lý sự kiện khi click nút xóa
        function onBtnXoaClick(paramBtnXoa) {
            $("#delete-confirm-modal").modal("show")
            // B1 Thu thập dữ liệu 
            var vRowSelected = $(paramBtnXoa).parents("tr")
            var vDataRow = gUserTable.row(vRowSelected).data()
            var vId = vDataRow.id
            $("#btn-confirm-delete-user").attr("id-object", `${vId}`)
        }
        // Hàm gọi APi để xóa user
        function processingApiToDeleteUser() {
            $.ajax({
                url: gBASE_URL + $("#btn-confirm-delete-user").attr("id-object"),
                type: "DELETE",
                success: function () {
                    // Hiển thị thông báo xóa thành công
                    alert("Đã xóa user thành công")
                    // Ẩn modal delete
                    $("#delete-confirm-modal").modal("hide")
                    // Tải lại bảng
                    getAllUser()

                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            })
        }
        //
    })
</script>

</html>